;File HL3LIDA.asm
.NOLIST
include HL3LIDA.inc
.code

;#########################################################################
;		Common AddIn Procedures
align	4
DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD

	mov		eax, [hInst]
	mov		[hInstance],eax
	mov		eax,TRUE
	ret

DllEntry Endp

InstallAddin proc EXPORT USES ebx hWin:DWORD

	mov		ebx,[hWin]

	xor		eax,	eax
	mov		[OldEditProc1],	eax
	mov		[OldEditProc2],	eax
	mov		[hEdt1],	eax
	mov		[hEdt2],	eax





	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;
	mov		[lpHandles],eax

	mov		edx,	[eax].ADDINHANDLES.hStatus
	mov		[hStatB],	edx


	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov		lpProc,eax
	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0
	mov		lpData,eax
	; Allocate a new menu id
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov		IDAddIn,eax

	mov eax,lpData
	add	eax,	ADDINDATA.szRadASMIni
	invoke SettingsLoadIni,hWin,eax

		mov eax,lpData
		add	eax,	ADDINDATA.szRadASMIni
		invoke	SettingsSaveIni,hWin,eax


	mov		hook.hook1,HOOK_RASELCHANGE	or HOOK_MDIACTIVATE or HOOK_COMMAND or HOOK_MENUUPDATE or HOOK_CLOSE
	xor		eax,eax
	mov		hook.hook2,eax
	mov		hook.hook3,eax
	mov		hook.hook4,eax
	mov		eax,offset hook
	ret

InstallAddin Endp





align	4
; Export this proc (it is autoexported if MakeDef is enabled with option 2)
; This proc handles messages sent from RadASM to our dll
; Return TRUE to prevent RadASM and other dll's from
; processing command.
AddinProc proc EXPORT hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from
LOCAL	RetVal	:DWORD
	mov	[RetVal],	TRUE

	mov	eax, [uMsg]
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.if edx == IDAddIn && eax == BN_CLICKED
			mov eax,lpHandles
			mov eax,[eax].ADDINHANDLES.hWnd
			invoke DialogBoxParamW,hInstance,IDD_DLG1,eax,addr DialogProc,NULL
			; Your addin has been selected
			mov eax,TRUE
			ret
		.endif
	.elseif eax==AIM_UNHOOK
		mov		eax,[hWin]
		mov		ecx,[wParam]
		mov		edx,[lParam]
		.if eax==[hEdt1] && ecx==[OldEditProc1]
			;Remove the hook from the chain
			mov		[OldEditProc1],edx
			mov		eax,TRUE
			jmp		Ex
		.elseif eax==[hEdt2] && ecx==[OldEditProc2]
			;Remove the hook from the chain
			mov		[OldEditProc2],edx
			mov		eax,TRUE
			jmp		Ex
		.endif

	.elseif eax==AIM_CLOSE
		;Undo subclassing
		.if [OldEditProc1]
			invoke UnHook,[hEdt1],offset RAEditProc,[OldEditProc1]
			mov		[OldEditProc1],0
		.endif
		.if [OldEditProc2]
			invoke UnHook,[hEdt2],offset RAEditProc,[OldEditProc2]
			mov		[OldEditProc2],0
		.endif
		mov edx,[lpHandles]
		invoke DeleteMenu,[edx].ADDINHANDLES.hMenu,[IDAddIn],MF_BYCOMMAND
		xor		eax,		eax
		mov		[IDAddIn],	eax


	.elseif eax==AIM_MDIACTIVATE
;This message is sendt when a mdi child is activated or deactivated.
; Always return FALSE. hWin=Mdi child window,wParam and lParam as M_MDIACIVATE

;		invoke	SendMessage,[hStatB],SB_GETPARTS,6,ADDR vSBA
;				;<
;				StatSize equ 300
;				invoke GetWindowRect,[hStatB],ADDR rect
;				mov		eax,	[rect.right]
;				sub		eax,	[rect.left]
;				sub		eax,	StatSize
;
;				mov		ecx,	[vSBA+4*2]
;				add		ecx,	StatSize
;				.if		ecx>eax
;					mov		eax,	ecx
;				.endif
;				mov		[vSBA+4*3],eax
;
;				mov		DWORD ptr [vSBA+4*4],-1
;				invoke	SendMessage,[hStatB],SB_SETPARTS,5,ADDR vSBA
;;				invoke	dwtoa,[cnt],ADDR vSBA
;				invoke	SendMessage,[hStatB],SB_SETTEXT,4, $TA0('HL_LIDA ON')
;				;>


		.if [hWin]
			mov		eax,	lpHandles
			mov		eax,	[eax].ADDINHANDLES.hEdt
			invoke GetWindowLong,eax,GWL_ID	;Get editor type ; the return value of a message processed in the dialog box procedure.
;PrintDec	eax
			.if  (eax==ID_EDITCODE) ;ID_EDIT
				mov		eax,[wParam]
				.if eax==[hWin]
					.if [OldEditProc1]
						;Unsubclass the RAEdit windows
						invoke UnHook,[hEdt1],offset RAEditProc,[OldEditProc1]
						invoke UnHook,[hEdt2],offset RAEditProc,[OldEditProc2]
						xor eax, eax
						mov [OldEditProc1],eax				;Set as unhooked
						mov [OldEditProc2],eax				;Set as unhooked
					.endif
				.else

;invoke	TextOutput,$TA0('\nINFO: Begin Subclass the RAEdit child windows.')

				;Subclass the RAEdit child windows
				invoke GetWindowLong,[lParam],GWL_USERDATA
				invoke GetWindowLong,eax,DWL_MSGRESULT	;the return value of a message processed in the dialog box procedure.
				mov		[lpEDIT_struct],	eax
				mov		edx,	[eax].EDIT.edta.hwnd
				mov		[hEdt1],edx
				mov		edx,	[eax].EDIT.edtb.hwnd
				mov		[hEdt2],edx
				;=======================================================
				; Check the richedit version
				;=======================================================
				invoke SendMessage,[hEdt1],EM_SETTYPOGRAPHYOPTIONS,TO_SIMPLELINEBREAK,TO_SIMPLELINEBREAK
				invoke SendMessage,[hEdt1],EM_GETTYPOGRAPHYOPTIONS,1,1
				.if eax==0		; means this message is not processed
					mov [RichEditVersion],2
;invoke	TextOutput,$TA0('\nINFO: RichEditVersion 2.')
				.else
					mov [RichEditVersion],3
;invoke	TextOutput,$TA0('\nINFO: RichEditVersion 3.')

					;=============================================================================
					; Make it emulate system edit control so the text color update doesn't  take very long
					;=============================================================================
					invoke SendMessage,[hEdt1],EM_SETEDITSTYLE,SES_EMULATESYSEDIT,SES_EMULATESYSEDIT
					invoke SendMessage,[hEdt2],EM_SETEDITSTYLE,SES_EMULATESYSEDIT,SES_EMULATESYSEDIT
				.endif

				;Subclass the RAEdit child windows
				invoke SetWindowLong,[hEdt1],GWL_WNDPROC,ADDR RAEditProc
				mov [OldEditProc1],eax
				invoke SetWindowLong,[hEdt2],GWL_WNDPROC,ADDR RAEditProc
				mov [OldEditProc2],eax
				mov		eax, TRUE
				jmp		Ex

				.endif
			.endif
		.endif
;	;
;
	.elseif	eax==AIM_RASELCHANGE	;AIM_EDITSELCHANGE
;This message is sendt when a ID_EDITCODE window has a selection change.
;Always return FALSE.
;hWin=Mdi child window,wParam=lpTABMEM,lParam=lpRASELCHANGE

;		invoke	TextOutput,$TA0('\nINFO: AIM_RASELCHANGE.')
		mov		eax,	[lParam]
		.if [eax].RASELCHANGE.seltyp == SEL_TEXT

			mov		edx,		[eax].RASELCHANGE.chrg.cpMin
;PrintDec	edx, "RASELCHANGE.chrg.cpMin"
			mov		[vBeginSel],	edx
			mov		ecx,		[eax].RASELCHANGE.chrg.cpMax
;PrintDec ecx, "RASELCHANGE.chrg.cpMax"
			sub		ecx,		edx
			.if SIGN?
				neg ecx
				m2m		[vBeginSel],	[eax].RASELCHANGE.chrg.cpMax
			.endif
			mov		[sizeHL],	ecx


	;		invoke	SendMessage,[wParam],EM_EXGETSEL,NULL,ADDR CR
	;		mov		edx,		[CR.cpMin]
	;		mov		[vBeginSel],	edx
	;		mov		ecx,		[CR.cpMax]
	;		sub		ecx,		edx
	;		mov		[sizeHL],	ecx

			.if	ecx<sizeof szHL || !ecx
				mov	eax,	[wParam]
				mov	edx,	[eax].TABMEM.hedt
				invoke	SendMessage,edx,EM_GETSELTEXT,NULL,ADDR szHL
				lea		edx,		[szHL]
				xor		eax,		eax
				mov		ecx,		[sizeHL]
				.while	ecx
					mov	al,	[edx+ecx-1]
					.if	al==10 || al==13 || al==' ' || al==09
						mov	[sizeHL],	0
					.endif
					dec	al
					and	al,	NOT(01fh)
					or	ah,	al
					dec	ecx
				.endw
				.if	!ah
					mov	[sizeHL],	eax
				.endif
				mov	eax,	[wParam]
				mov	edx,	[eax].TABMEM.hedt
				invoke SendMessage,edx,REM_REPAINT,1,0
			.else
				xor		eax,	eax
				mov		[sizeHL],	eax
			.endif
		.endif
		return	TRUE
	.elseif	eax==AIM_ADDINSLOADED
;		.if	[fNeedHook]==1
;			mov		[fNeedHook],0
;			invoke	TextOutput,$TA0('\n\nINFO: Please reopen file.\n\n')
;		.endif
	.elseif eax==AIM_MENUUPDATE
		invoke UpdateMenu,wParam
	.endif
	xor		eax,	eax
  Ex:
	ret
AddinProc Endp

;align	4
;;#########################################################################
;GetOptions proc
;	mov		eax,offset AddinOpt
;	ret
;GetOptions endp
align	4

UnHook proc hWin:HWND,lpThisProc:DWORD,lpOldProc:DWORD

	invoke GetWindowLong,[hWin],GWL_WNDPROC
	.if eax==[lpThisProc]
		;Last in chain, just unhook
		invoke SetWindowLong,[hWin],GWL_WNDPROC,[lpOldProc]
	.else
		;Let the next in the chain unhook me
;		push	RAM_UNHOOK
;		push	[lpOldProc]
;		push	[lpThisProc]
;		push	AIM_UNHOOK
;		push	[hWin]
;		mov		eax,[lpProc]
;		call	[eax].ADDINPROCS.???????
	.endif
	ret

UnHook endp

align	4
RAEditProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD,lParam:DWORD
	LOCAL txtrange:TEXTRANGE
	LOCAL RealRect:RECT
	LOCAL rect:RECT
	LOCAL FirstChar:DWORD
	LOCAL hOldFont:DWORD
	LOCAL hOldRgn:DWORD
	LOCAL hREdit:DWORD
	LOCAL hRgn:DWORD
	LOCAL hdc:DWORD
	LOCAL cnt:DWORD
	LOCAL CntWord:DWORD
	LOCAL	CntNoCase:DWORD
	LOCAL W:DWORD
	LOCAL OLDedi:DWORD
	LOCAL OLDesi:DWORD
	LOCAL SizeInBuf:DWORD
	.if uMsg==WM_PAINT
		mov	[OLDedi], edi
		mov	[OLDesi], esi

		mov eax,	[lpHandles]
		mov	eax,	[eax].ADDINHANDLES.hEdt
		mov	[hREdit],eax

		invoke HideCaret,[hWnd]

		invoke CallWindowProc,[OldEditProc1],[hWnd],[uMsg],[wParam],[lParam]
		push eax
;##\
;jmp	skip

		.if [sizeHL]
			invoke GetDC,[hWnd]
			mov [hdc],eax

			mov		eax,	[lpHandles]
			invoke SelectObject,[hdc],[eax].ADDINHANDLES.racf.hFont
			mov		[hOldFont],eax

			invoke SetBkMode,[hdc],OPAQUE

;			test	[fOptions],O_BB
;			.if	!ZERO?
;				invoke SetTextColor,[hdc],1
;				invoke SetBkColor,[hdc], 00FF0000h
;			.endif
;
;			test	[fOptions],O_BG
;			.if	!ZERO?
;				invoke SetTextColor,[hdc],1
;				invoke SetBkColor,[hdc], 0000FF00h
;			.endif
;
;			test	[fOptions],O_BR
;			.if	!ZERO?
;				invoke SetTextColor,[hdc],1
;				invoke SetBkColor,[hdc], 000000FFh
;			.endif

			;===================================================================
			; Do syntax hiliting here!
			;===================================================================
			invoke SendMessage,[hREdit],EM_GETRECT,0,addr rect

			invoke SendMessage,[hREdit],EM_CHARFROMPOS,0,ADDR rect.left
			;========================================================
			; obtain the line number
			;========================================================
			invoke SendMessage,[hREdit],EM_LINEFROMCHAR,eax,0
			invoke SendMessage,[hREdit],EM_LINEINDEX,eax,0
			mov		[txtrange.chrg.cpMin],eax
			mov		[FirstChar],eax
	;
			invoke SendMessage,[hREdit],EM_CHARFROMPOS,0,addr rect.right
			mov		[txtrange.chrg.cpMax],eax

			sub		eax,	[FirstChar]
			mov		[SizeInBuf],	eax
			.if eax < sizeof buffer
				push	[rect.left]
				pop		[RealRect.left]
				push	[rect.top]
				pop		[RealRect.top]
				push	[rect.right]
				pop		[RealRect.right]
				push	[rect.bottom]
				pop		[RealRect.bottom]
				invoke CreateRectRgn,[RealRect.left],[RealRect.top],[RealRect.right],[RealRect.bottom]
				mov		[hRgn],eax
				invoke SelectObject,[hdc],[hRgn]
				mov		[hOldRgn],eax

				;< Get the visible text into buffer
				lea		eax,[buffer]
				mov		[txtrange.lpstrText],eax
				invoke SendMessage,[hREdit],EM_GETTEXTRANGE,0,ADDR txtrange
				mov edx,eax		; edx == size of the text
				;>
				lea		eax,	[buffer]
				mov		edi,	eax	; 

				xor		eax,					eax
				mov		[cnt],				eax
				mov		[CntWord],		eax
				mov		[CntNoCase],	eax
				.while edx>0
					push	edx

					mov		ecx,	[sizeHL]
					xor		eax,eax
					mov		[szOrigin+ecx],al	;Terminate NULL
					.while	ecx
						mov		dl,	[edi+ecx-1]	;
						mov		[szOrigin+ecx-1],dl

						xor		al,	dl;	[edi+ecx-1]	;
						xor		al,	[szHL+ecx-1]
						or		ah,	al
						dec		ecx
					.endw



					.if	ah==0 || ah ==20h
						.if	ah == 0
							inc	[cnt]	;Increment counter
							invoke SetTextColor,[hdc],[HL_Colors].StringText
							invoke SetBkColor,[hdc],[HL_Colors].StringBack
							;ADDINDATA.radcolor.racol.hicol1 = Comments back

						.elseif	ah == 20h
							;< No mach case
							inc	[CntNoCase]
							invoke SetTextColor,[hdc],[HL_Colors].CaseText
							mov	eax,	lpData
							invoke SetBkColor,[hdc],[HL_Colors].CaseBack
							;>No mach case
						.endif
						
						;< Is whole word.
						;edi = (offset buffer) and [edi+sizeHL] = SP or TAB or CR
						;[edi-1] = SP or TAB or CR and [edi+sizeHL] = SP or TAB or CR
						;[edi-1] = SP or TAB or CR and edi = (offset buffer + SizeInBuf - sizeHL)
						lea		ecx,	[buffer]
						mov		edx,	ecx			;edx = (offset buffer)
						add		ecx,	[SizeInBuf]
						sub		ecx,	[sizeHL]	;ecx = (offset buffer + SizeInBuf - sizeHL)

						.if edi ==  edx	;Selected text in the begin of buffer
							;< Selected text into beginning
							mov		edx,	[sizeHL]
							invoke TstSepar,[edi+edx]	;[edi+sizeHL]
							.if al
								inc [CntWord]
								jmp	@F
							.endif
							;> Selected text into beginning
						.elseif edi == ecx ;Selected text in the ending of buffer
							;< Selected text the terminate
							invoke TstSepar,[edi-1]
							.if al
								inc [CntWord]
								jmp	@F
							.endif
							;> Selected text the terminate
							.else ;Selected text in the mid of buffer
							mov		edx,	[sizeHL]
							invoke TstSepar,[edi+edx]
							.if	al
								invoke TstSepar,[edi-1]
								.if al
									inc [CntWord]
									@@:
									invoke SetTextColor,[hdc],[HL_Colors].WordText
									invoke SetBkColor,[hdc],[HL_Colors].WordBack
								.endif
							.endif
						.endif
						;> Is whole word
						;> Is whole word word4

						mov ecx,edi
						lea edx,[buffer]
						sub ecx,edx
						add ecx,[FirstChar]

						push	ecx

						add	ecx,	[sizeHL]

						push	edi
						mov		edi,	[OLDedi]
						invoke SendMessage,[hREdit],EM_POSFROMCHAR,addr rect,ecx
						pop		edi

						mov		eax,	[rect.left]
						mov		[W],		eax

						mov ecx,edi
						lea edx,[buffer]
						sub ecx,edx
						add ecx,[FirstChar]

						push	edi
						mov	edi,	[OLDedi]
						invoke SendMessage,[hREdit],EM_POSFROMCHAR,addr rect,ecx
						pop	edi

						mov		eax,	[rect.left]
						sub		[W],		eax
						pop	ecx
						.if	ecx==[vBeginSel]
							invoke GetTextColor,[hdc]
							push	eax
							invoke GetBkColor,[hdc]
							push	eax

							invoke SetTextColor,[hdc],[HL_Colors].SelectText
							invoke SetBkColor,[hdc],[HL_Colors].SelectBack
								invoke DrawText,[hdc],ADDR szOrigin,[sizeHL],ADDR rect,DT_MODIFYSTRING
							pop		eax
							invoke SetBkColor,[hdc],eax
							pop		eax
							invoke SetTextColor,[hdc],eax
						.else
							invoke DrawText,[hdc],ADDR szOrigin,[sizeHL],ADDR rect,DT_MODIFYSTRING
						.endif
						add	edi,[sizeHL]
					.else
						inc edi
					.endif
					pop		edx
					dec edx
				.endw
				invoke SelectObject,[hdc],[hOldFont]

				invoke SelectObject,[hdc],[hOldRgn]
				invoke DeleteObject,[hRgn]

				invoke ReleaseDC,[hWnd],[hdc]

				invoke OutStatBar,CntWord,cnt,CntNoCase
;				InVoke
			.endif

		.else
			;
			mov		DWORD ptr [vSBA+4*3],-1
			invoke	SendMessage,[hStatB],SB_SETPARTS,4,ADDR vSBA
			;
		.endif

		invoke ShowCaret,[hWnd]
;##/
skip:
		pop eax
		mov	edi,	[OLDedi]
		mov	esi,	[OLDesi]
	.elseif [uMsg]==WM_CLOSE
		invoke SetWindowLong,[hWnd],GWL_WNDPROC,[OldEditProc1]
		invoke CallWindowProc,[OldEditProc1],[hWnd],[uMsg],[wParam],[lParam]
	.else
		invoke CallWindowProc,[OldEditProc1],[hWnd],[uMsg],[wParam],[lParam]
	.endif
	ret
RAEditProc endp
;Return AL = 0 if char isn't separator
TstSepar proc USES EDX ECX Char:BYTE
	lea		edx,	[CSepar]
	xor		ecx,	ecx
	mov		ah,		[Char]
	.repeat
		mov		al,	[edx+ecx]
		test	al,al
		.break .if	ZERO?
		inc		ecx
		cmp		ah,	al
	.until ZERO?

	ret
TstSepar endp
CSepar DB 13,' ','!',09,'.',',',';',':','"',"'",'=','+','-','/','*','[',']','(',')','<','>',0

OutStatBar proc CntW:DWORD,CntM:DWORD,CntCase:DWORD
LOCAL rect:RECT
LOCAL	Buf128[128]:BYTE
;<
	invoke	SendMessage,[hStatB],SB_GETPARTS,6,ADDR vSBA

;PrintDec CntWord
	StatSize equ 250

	invoke GetWindowRect,[hStatB],ADDR rect
	mov		eax,	[rect.right]
	sub		eax,	[rect.left]
	sub		eax,	StatSize

	mov		ecx,	[vSBA+4*2]
	add		ecx,	StatSize
	.if		ecx>eax
		mov		eax,	ecx
	.endif
	mov		[vSBA+4*3],eax

	mov		DWORD ptr [vSBA+4*4],-1
	invoke	SendMessage,[hStatB],SB_SETPARTS,5,ADDR vSBA
	invoke	wsprintf,ADDR Buf128,$TA0('On Page: Words %d / Strings %d / No case %d'),CntW,CntM,CntCase
;	invoke	dwtoa,[CntM],ADDR vSBA
	invoke	SendMessage,[hStatB],SB_SETTEXT,4,ADDR Buf128
	;>
	ret
OutStatBar endp

UpdateMenu proc hMnu:HMENU
	LOCAL	mii:MENUITEMINFO

	mov		mii.cbSize,sizeof MENUITEMINFO
	mov		mii.fMask,MIIM_SUBMENU
	mov		edx,lpHandles
	invoke GetMenuItemInfo,[edx].ADDINHANDLES.hMenu,IDM_TOOLS,FALSE,addr mii
	invoke AppendMenu,mii.hSubMenu,MF_STRING,IDAddIn,$TA0('HighLight Like IDA')
	ret

UpdateMenu endp

DialogProc proc hwnd:HWND,umsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL dwID:DWORD
LOCAL dwEdit:DWORD
LOCAL hEdit:HWND
LOCAL szBuffer[128]:BYTE
LOCAL color  :DWORD
LOCAL	hdc:DWORD
LOCAL	hID:DWORD
	.if umsg==WM_INITDIALOG
		m2m	tHL_Colors.WordText,HL_Colors.WordText
		m2m	tHL_Colors.WordBack,HL_Colors.WordBack
		m2m	tHL_Colors.StringText,HL_Colors.StringText
		m2m	tHL_Colors.StringBack,HL_Colors.StringBack
		m2m	tHL_Colors.CaseText,HL_Colors.CaseText
		m2m	tHL_Colors.CaseBack,HL_Colors.CaseBack
		m2m	tHL_Colors.SelectText,HL_Colors.SelectText
		m2m	tHL_Colors.SelectBack,HL_Colors.SelectBack

		call	CrBrush

;< It's code not working ???? Why ?????
;	.elseif umsg==WM_CTLCOLORBTN
;		invoke GetDlgItem,hwnd,IDC_WT
;		.if eax==lParam
;			invoke	SetTextColor,wParam,HL_Colors.WordText
;			invoke	SetBkColor,wParam,HL_Colors.WordText
;			mov	eax,hBrushWordText
;			ret
;		.endif
;		invoke GetDlgItem,hwnd,IDC_WB
;		.if eax==lParam
;			invoke	SetTextColor,wParam,HL_Colors.WordText
;			invoke	SetBkColor,wParam,HL_Colors.WordBack
;			mov	eax,hBrushWordBack
;			ret
;		.endif
;> It's code not working ???? Why ?????




	.elseif umsg==WM_CTLCOLORSTATIC
		invoke GetDlgItem,hwnd,IDWORD
		.if eax==lParam
			invoke	SetTextColor,wParam,tHL_Colors.WordText
			invoke	SetBkColor,wParam,tHL_Colors.WordBack
			mov	eax,hBrushWordBack
			ret
		.endif
		invoke GetDlgItem,hwnd,IDSTRING
		.if eax==lParam
			invoke	SetTextColor,wParam,tHL_Colors.StringText
			invoke	SetBkColor,wParam,tHL_Colors.StringBack
			mov	eax,hBrushStringBack
			ret
		.endif
		invoke GetDlgItem,hwnd,IDCASE
		.if eax==lParam
			invoke	SetTextColor,wParam,tHL_Colors.CaseText
			invoke	SetBkColor,wParam,tHL_Colors.CaseBack
			mov	eax,hBrushCaseBack
			ret
		.endif
		invoke GetDlgItem,hwnd,IDSEL
		.if eax==lParam
			invoke	SetTextColor,wParam,tHL_Colors.SelectText
			invoke	SetBkColor,wParam,tHL_Colors.SelectBack
			mov	eax,hBrushSelectBack
			ret
		.endif

	.elseif umsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			and eax,0FFFFFFh
			mov dwID,eax
			.if (dwID == IDOK)

    		m2m HL_Colors.WordText  	,tHL_Colors.WordText
				m2m HL_Colors.WordBack  	,tHL_Colors.WordBack
				m2m HL_Colors.StringText	,tHL_Colors.StringText
				m2m HL_Colors.StringBack	,tHL_Colors.StringBack
				m2m HL_Colors.CaseText  	,tHL_Colors.CaseText
				m2m HL_Colors.CaseBack  	,tHL_Colors.CaseBack
				m2m HL_Colors.SelectText  	,tHL_Colors.SelectText
				m2m HL_Colors.SelectBack  	,tHL_Colors.SelectBack
				
				invoke	SendMessage,hwnd,WM_CLOSE,NULL,NULL
			.elseif dwID==IDCANCEL
				invoke	SendMessage,hwnd,WM_CLOSE,NULL,NULL
				
			.elseif dwID==IDC_WT
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.WordText
				jmp	@F;	invoke ColorDlg,NULL,hInstance,eax,CC_RGBINIT; or CC_ENABLETEMPLATE
				
			.elseif dwID==IDC_WB
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.WordBack
				jmp	@F;		invoke ColorDlg,NULL,hInstance,eax,CC_FULLOPEN or CC_RGBINIT; or CC_ENABLETEMPLATE
				
 			.elseif dwID==IDC_ST
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.StringText
				jmp	@F;		invoke ColorDlg,NULL,hInstance,eax,CC_FULLOPEN or CC_RGBINIT; or CC_ENABLETEMPLATE
				
			.elseif dwID==IDC_SB
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.StringBack
				jmp	@F;		invoke ColorDlg,NULL,hInstance,eax,CC_FULLOPEN or CC_RGBINIT; or CC_ENABLETEMPLATE
				
			.elseif dwID==IDC_CT
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.CaseText
				jmp	@F;		invoke ColorDlg,NULL,hInstance,eax,CC_FULLOPEN or CC_RGBINIT; or CC_ENABLETEMPLATE
				
			.elseif dwID==IDC_CB
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.CaseBack
				jmp	@F;		invoke ColorDlg,NULL,hInstance,eax,CC_FULLOPEN or CC_RGBINIT; or CC_ENABLETEMPLATE
				
			.elseif dwID==IDC_SELT
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.SelectText
				jmp	@F;		invoke ColorDlg,NULL,hInstance,eax,CC_FULLOPEN or CC_RGBINIT; or CC_ENABLETEMPLATE
				
			.elseif dwID==IDC_SELB
        ; return value in EAX is COLORREF for selected color.
				lea eax,tHL_Colors.SelectBack
				@@:
				invoke ColorDlg,hwnd,hInstance,eax,CC_RGBINIT
				call	DelBrush
				call	CrBrush
				invoke	InvalidateRgn,hwnd,NULL,TRUE
			.else
				mov eax,FALSE
				ret
			.endif
			
		.endif
	.elseif umsg==WM_CLOSE
		call	DelBrush
		invoke EndDialog,hwnd,NULL
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	Ret
DialogProc EndP


;#########################################################################
;		Output Window procs

TextOutput proc lpszStr
   pushad
   push  lpszStr
   mov   eax,[lpProc]
   call  [eax].ADDINPROCS.lpTextOutput
   popad
   ret
TextOutput endp


OutputString proc uses ebx,lpString:DWORD

	mov		ebx,lpProc
	push	0
	call	[ebx].ADDINPROCS.lpSetOutputTab
	push	TRUE
	call	[ebx].ADDINPROCS.lpShowOutput
	push	lpString
	call	[ebx].ADDINPROCS.lpTextOutput
	ret

OutputString endp
SettingsLoadIni proc uses esi edi ebx hDlg:dword,pIniFilename:dword
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('WordText'),000000Feh,pIniFilename
	mov	[HL_Colors].WordText,eax
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('WordBack'),0000FF00h,pIniFilename
	mov	[HL_Colors].WordBack,eax
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('StringText'),0FFFF80h,pIniFilename
	mov	[HL_Colors].StringText,eax
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('StringBack'),0404080h,pIniFilename
	mov	[HL_Colors].StringBack,eax
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('CaseText'),080FFFFh,pIniFilename
	mov	[HL_Colors].CaseText,eax
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('CaseBack'),0400040h,pIniFilename
	mov	[HL_Colors].CaseBack,eax
	
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('SelectText'),00000000h,pIniFilename
	mov	[HL_Colors].SelectText,eax
	invoke GetPrivateProfileInt, $TA0('HL3LIDA'),$TA0('SelectBack'),00C8E01Fh,pIniFilename
	mov	[HL_Colors].SelectBack,eax
	ret
SettingsLoadIni endp

SettingsSaveIni proc uses esi edi ebx hDlg:dword,pIniFilename:dword
	LOCAL	buf20[20]:BYTE
	invoke	wsprintf,ADDR buf20,$TA0('%d'),[HL_Colors].WordText
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('WordText'),ADDR buf20,pIniFilename
	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].WordBack
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('WordBack'),ADDR buf20,pIniFilename
	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].StringText
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('StringText'),ADDR buf20,pIniFilename
	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].StringBack
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('StringBack'),ADDR buf20,pIniFilename
	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].CaseText
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('CaseText'),ADDR buf20,pIniFilename
	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].CaseBack
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('CaseBack'),ADDR buf20,pIniFilename

	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].SelectText
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('SelectText'),ADDR buf20,pIniFilename
	invoke	wsprintf,ADDR buf20,$TA0('%d'),	[HL_Colors].SelectBack
	invoke WritePrivateProfileString, $TA0('HL3LIDA'),$TA0('SelectBack'),ADDR buf20,pIniFilename
	ret
SettingsSaveIni endp


ColorDlg proc USES EDI hWin:DWORD, instance:DWORD,lpInitColor:DWORD, Flags:DWORD
	;Common dialog process
	LOCAL ccl:CHOOSECOLOR
	LOCAL crv[16]:DWORD

	lea edi,crv[0]
	mov ecx,16
	mov eax,0FFFFFFh
	rep stosd

	mov ccl.lStructSize,sizeof CHOOSECOLOR
	push hWin
	pop ccl.hwndOwner
	push instance
	pop ccl.hInstance
	mov eax,lpInitColor
	mov	eax,	[eax]
	mov ccl.rgbResult,eax

	; address of 16 item DWORD array
	mov ccl.lpCustColors,OFFSET CustColor
	push Flags
	pop ccl.Flags
	mov ccl.lCustData,0
	mov ccl.lpfnHook,0;OFFSET CCHookProc
	mov ccl.lpTemplateName,0;OFFSET szTemplate

	invoke ChooseColor,addr ccl

	;Is the colordialog canceled
	.if eax!= 0
		mov eax,ccl.rgbResult
		mov	edi, lpInitColor
		mov	[edi],eax
	.endif
	ret
ColorDlg endp

CrBrush	proc
		invoke	CreateSolidBrush,tHL_Colors.WordText
		mov		hBrushWordText,	eax
		invoke	CreateSolidBrush,tHL_Colors.WordBack
		mov		hBrushWordBack,	eax
		invoke	CreateSolidBrush,tHL_Colors.StringText
		mov		hBrushStringText,	eax
		invoke	CreateSolidBrush,tHL_Colors.StringBack
		mov		hBrushStringBack,	eax
		invoke	CreateSolidBrush,tHL_Colors.CaseText
		mov		hBrushCaseText,	eax
		invoke	CreateSolidBrush,tHL_Colors.CaseBack
		mov		hBrushCaseBack,	eax
		invoke	CreateSolidBrush,tHL_Colors.SelectText
		mov		hBrushSelectText,	eax
		invoke	CreateSolidBrush,tHL_Colors.SelectBack
		mov		hBrushSelectBack,	eax
	ret
CrBrush endp

DelBrush proc
		invoke	DeleteObject,hBrushWordText
		invoke	DeleteObject,hBrushWordBack
		invoke	DeleteObject,hBrushStringText
		invoke	DeleteObject,hBrushStringBack
		invoke	DeleteObject,hBrushCaseText
		invoke	DeleteObject,hBrushCaseBack
		invoke	DeleteObject,hBrushSelectText
		invoke	DeleteObject,hBrushSelectBack
	ret
DelBrush endp
End DllEntry
