include masm32rt.inc
;#########################################################################
;		RadASM Add In Include
	include	..\ADDINs.inc
	include \masm32\macros\strings.mac

;#########################################################################
;		VKim's Debug
include Debug.Inc
includelib Debug.lib
include EQUs.inc


AIM_UNHOOK				equ WM_USER+132			;hWnd=handle of window to unhook,wParam=proc to unhook, lParam=previous proc

	DBGWIN_DEBUG_ON = 1		; include debug info into the program
	DBGWIN_EXT_INFO = 0		; include extra debug info into the program

;#########################################################################
;		Prototypes
include	Proto.inc
ID_EDIT 						= 65501
;
RABRUSH struct
	hBrBck		dd ?			;Back color brush
	hBrSelBck	dd ?			;Sel back color brush
	hBrHilite1	dd ?			;Line hilite 1
	hBrHilite2	dd ?			;Line hilite 2
	hBrHilite3	dd ?			;Line hilite 3
	hBrSelBar	dd ?			;Selection bar
	hPenSelbar	dd ?			;Selection bar pen
RABRUSH ends


RAFONTINFO struct
	charset		dd ?			;Character set
	fDBCS		dd ?			;Use double byte characters
	fntwt		dd ?			;Font width
	fntht		dd ?			;Font height
	spcwt		dd ?			;Space width
	tabwt		dd ?			;Tab width
	italic		dd ?			;Height shift
	monospace	dd ?			;Font is monospaced
	linespace	dd ?			;Extra line spacing
RAFONTINFO ends

RAEDT struct
	hwnd		dd ?			;Handle of edit a or b
	hvscroll	dd ?			;Handle of scroll bar
	cpxmax		dd ?			;Last cursor pos x
	cpy			dd ?			;Scroll position
	cp			dd ?			;Character position
	rc			RECT <?>		;Edit a or b rect
	topyp		dd ?			;First visible lines Y position
	topln		dd ?			;First visible lines linenumber
	topcp		dd ?			;First visible lines character position
RAEDT ends


EDIT struct
	hwnd		dd ?			;Handle of main window
	fstyle		dd ?			;Window style
	ID			dd ?			;Window ID
	hpar		dd ?			;Handle of parent window
	edta		RAEDT <>
	edtb		RAEDT <>
	hhscroll	dd ?			;Handle of horizontal scrollbar
	hgrip		dd ?			;Handle of sizegrip
	hnogrip		dd ?			;Handle of nosizegrip
	hsbtn		dd ?			;Handle of splitt button
	hlin		dd ?			;Handle of linenumber button
	hexp		dd ?			;Handle of expand button
	hcol		dd ?			;Handle of collapse button
	hsta		dd ?			;Handle of state window
	htt			dd ?			;Handle of tooltip
	fresize		dd ?			;Resize in action flag
	fsplitt		dd ?			;Splitt factor
	nsplitt		dd ?			;Splitt height

	hHeap		dd 3 dup(?)		;Handle of heap
	hLine		dd ?			;Handle of line pointer mem
	cbLine		dd ?			;Size of line pointer mem
	rpLine		dd ?			;Relative pointer into line pointer mem
	rpLineFree	dd ?			;Pointer to free line pointer
	hChars		dd ?			;Handle of character mem
	cbChars		dd ?			;Size of character mem
	rpChars		dd ?			;Relative pointer into character mem
	rpCharsFree	dd ?			;Relative pointer to free character
	hUndo		dd ?			;Handle of undo memory
	cbUndo		dd ?			;Size of undo memory
	rpUndo		dd ?			;Relative pointer to free (last)
	line		dd ?			;Linenumber
	cpLine		dd ?			;Character position for start of line

	rc			RECT <?>		;Main rect
	selbarwt	dd ?			;Width of selection bar
	nlinenrwt	dd ?			;Initial width of linenumber bar
	linenrwt	dd ?			;Width of linenumber bar
	nScroll		dd ?			;Mouse wheel scroll lines
	nPageBreak	dd ?			;Page break
	cpMin		dd ?			;Selection min
	cpMax		dd ?			;Selection max
	fOvr		dd ?			;Insert / Overwrite
	nHidden		dd ?			;Number of hidden lines
	cpx			dd ?			;Scroll position
	focus		dd ?			;Handle of edit having focus
	fCaretHide	dd ?			;Caret is hidden
	fChanged	dd ?			;Content changed
	fHideSel	dd ?			;Hide selection
	fIndent		dd ?			;Auto indent
	clr			RACOLOR <?>
	br			RABRUSH <?>
	nTab		dd ?			;Tab size
	fnt			RAFONT <?>
	fntinfo		RAFONTINFO <?>
	lpBmCB		dd ?			;Bookmark paint callback
	nchange		dd ?			;Used by EN_SELCHANGE
	nlastchange	dd ?			;Used by EN_SELCHANGE
	nWordGroup	dd ?			;Hilite word group
	fExpandTab	dd ?			;TRUE/FALSE Epand tabs to spaces
	savesel		CHARRANGE <?>
	htlt		dd ?			;Scroll tooltip
	nMode		dd ?			;Block selection
	blrg		BLOCKRANGE <?>
	lockundoid	dd ?
	ccmntblocks	dd ?
EDIT ends

HLLIDACOLOR struct
	WordText		dd ?
	WordBack		dd ?
	StringText	dd ?
	StringBack	dd ?
	CaseText		dd ?
	CaseBack		dd ?
	SelectText	dd ?
	SelectBack	dd ?
HLLIDACOLOR ends


.LIST
.data
;szOnPageFormat	db 'On page: '
vSBA			dd 8 DUP(0)
;DTParam			DRAWTEXTPARAMS<sizeof DRAWTEXTPARAMS,,,,>

;szOpt1	db 'Enable',0
;szOpt2	db 'Black/White',0
;szOpt3	db 'Black/Blue',0
;szOpt4	db 'Black/Green',0
;szOpt5	db 'Black/Red',0
;szOpt6	db 'szOpt6',0
;szOpt7	db 'szOpt7',0
;szOpt8	db 'szOpt8',0

O_EN	equ 00000001b
O_BW	equ	00000010b
O_BB	equ	00000100b
O_BG	equ	00001000b
O_BR	equ	00010000b
O_C3	equ	00100000b
O_C4	equ	01000000b
O_C5	equ	10000000b
;										AND		OR
;AddinOpt	ADDINOPT <offset szOpt1,O_EN,O_EN>
;			ADDINOPT <offset szOpt2,O_BW OR O_BB OR O_BG OR O_BR ,O_BW>
;			ADDINOPT <offset szOpt3,O_BW OR O_BB OR O_BG OR O_BR ,O_BB>
;			ADDINOPT <offset szOpt4,O_BW OR O_BB OR O_BG OR O_BR ,O_BG>
;			ADDINOPT <offset szOpt5,O_BW OR O_BB OR O_BG OR O_BR ,O_BR>
;;			ADDINOPT <offset szOpt6,00000001b,00000001b>
;;			ADDINOPT <offset szOpt7,00000001b,00000001b>
;;			ADDINOPT <offset szOpt8,00000001b,00000001b>
;			ADDINOPT <0,0,0>

;binDecade	dd 3B9ACA00h
;			dd 05F5E100h
;			dd 00989680h
;			dd 000F4240h
;			dd 000186A0h
;			dd 00002710h
;			dd 000003E8h
;			dd 00000064h
;			dd 0000000Ah
;			dd 00000001h

.NOLIST




.data?
	hInstance			dd ?	;Dll's module handle
	lpHandles		dd ?	;Pointer to handles struct
	lpProc			dd ?	;Pointer to proc struct
	lpData			dd ?	;Pointer to data struct
	IDAddIn				dd ?	;Unique ID for this AddIn
;	hOut				dd ?	;Handle of output window


hEdt1			dd ?
OldEditProc1	dd ?
hEdt2			dd ?
OldEditProc2	dd ?

RichEditVersion	dd ?

szHL			db	64 dup(?)
szOrigin	db	64 dup(?)

sizeHL			dd ?
lpEDIT_struct	dd ?
flgHL			dd ?

vCF			CHARFORMAT2<>
hStatB			dd ?
nTab			dd ?
fOptions		dd ?
vBeginSel		dd ?

;fNeedHook		dd ?


buffer	db 1024*10 DUP(?)

hBrushWordText DWORD ?
hBrushWordBack DWORD ?
hBrushStringText DWORD ?
hBrushStringBack DWORD ?
hBrushCaseText DWORD ?
hBrushCaseBack DWORD ?
hBrushSelectText DWORD ?
hBrushSelectBack DWORD ?

;txtrange	TEXTRANGE <>
;RealRect	RECT<>
Grect		RECT<>
;FirstChar	DD ?	;:DWORD
;hOldFont	DD ?	;:DWORD
;hOldRgn	DD ?	;:DWORD
;hREdit	DD ?	;:DWORD
;hRgn	DD ?	;:DWORD
;hdc	DD ?	;:DWORD
;cnt	DD ?	;:DWORD
;W	DD ?	;:DWORD
;OLDedi	DD ?	;:DWORD
;OLDesi	DD ?	;:DWORD dword

hook				HOOK <>
HL_Colors	HLLIDACOLOR<>
tHL_Colors HLLIDACOLOR<>
CustColor DD 16 DUP(?)
.code

